<%@ taglib prefix="cq" uri="http://www.day.com/taglibs/cq/1.0" %>
<%@include file="../../../../libs/foundation/global.jsp" %>
<cq:includeClientLib categories="xtype" />

<%@ page import="org.apache.commons.lang3.StringUtils" %>
<%@ page import="org.apache.commons.lang3.ArrayUtils" %>
<%@ page import="org.apache.sling.commons.json.JSONObject" %>
<%@ page import="org.apache.sling.commons.json.JSONTokener" %>
<%@ page import="org.apache.sling.commons.json.JSONException" %>

<style>
    div {
        width: auto;
        margin-bottom: 2px;
    }

    #box-table-a {
        font-family: "Lucida Sans Unicode", "Lucida Grande", Sans-Serif;
        font-size: 12px;
        margin: 45px;
        width: 320px;
        text-align: left;
        border-collapse: collapse;
    }

    #box-table-a th {
        font-size: 13px;
        font-weight: normal;
        padding: 8px;
        background: #b9c9fe;
        border-top: 4px solid #aabcfe;
        border-bottom: 1px solid #fff;
        color: #039;
    }

    #box-table-a td {
        padding: 8px;
        background: #e8edff;
        border-bottom: 1px solid #fff;
        color: #669;
        border-top: 1px solid transparent;
    }

    #ver-minimalist {
        font-family: "Lucida Sans Unicode", "Lucida Grande", Sans-Serif;
        font-size: 12px;
        margin: 45px;
        width: 580px;
        text-align: left;
        border-collapse: collapse;
    }

    #ver-minimalist th {
        padding: 8px 2px;
        font-weight: normal;
        font-size: 14px;
        color: #039;
    }
</style>

<%
    boolean isPropertyForAsset = properties.get("isPropertyForAsset",false);
    String[] options = (String[]) properties.get("options", String[].class);
%>

<div class="fieldConfig" style="border:1px solid #d3d3d3;padding-left:10px;border-radius: 3px;background-color: white;">

    <table id="ver-minimalist" summary="">
        <thead>
        <tr>
            <%
                if (isPropertyForAsset) {
            %>
            <th scope="col">Resource Type:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Digital Asset Properties</th>
            <%
            } else {
            %>
            <th scope="col">Resource Type:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%= properties.get("resourceType", "")%>
            </th>
            <% } %>
        </tr>
        </thead>
        <tbody>
        </tbody>
    </table>
    <table id="box-table-a" summary="Properties">
        <thead>
        <tr>
            <th scope="col">Properties</th>
            <th scope="col">Parsers</th>
        </tr>
        </thead>
        <tbody>
        <%
            if (ArrayUtils.isNotEmpty(options)) {
                for (String option : options) {
                    if (StringUtils.isNotEmpty(option) && option.contains("parser")) {
                        String property = StringUtils.EMPTY;
                        String parserDescription = StringUtils.EMPTY;
                        try {
                            JSONObject propertyMappingJsonObject = new JSONObject(new JSONTokener(option));
                            property = propertyMappingJsonObject.getString("property");
                            parserDescription = propertyMappingJsonObject.getString("parserDescription");
                        } catch (JSONException ex) {
        %>
                            Can't parse property <%=option%>
        <%
                        }
        %>
        <tr>
            <td><%=property%>
            </td>
            <td><%=parserDescription%>
            </td>
        </tr>
        <%
                    } else {
        %>
        <tr>
            <td><%=option%>
            </td>
            <td>HTML
            </td>
        </tr>
        <%
                    }
                }
            }
        %>
        </tbody>
    </table>
</div>
