;(function(document, $) {
    "use strict";

    var DOWNLOAD_URL = '/services/smartling/submission/bulk/download';

    var downloadButton;
    var ui;

    $(document).on("foundation-contentloaded", function(e){
		if (!downloadButton) {
			downloadButton = new DownloadButton();
			downloadButton.initialize();
		}

		 ui = $(window).adaptTo("foundation-ui");
	});

	var DownloadButton = new Class({

		$downloadButton: null,

		initialize: function () {
			var self = this;
			self.$downloadButton = document.querySelector(".smartling-submission-download");

            if (!self.$downloadButton) {
                return;
            }

			Coral.commons.ready(self.$downloadButton, function() {

				self.$downloadButton.on('click', function(event){
				    ui.prompt('Confirmation', 'Are you sure want to proceed?', 'notice', [
                        {id: 'smartling-download-confirmation', text: 'Yes', primary: true, handler: self._downloadAction},
                        {id: 'smartling-download-declining', text: 'No'}
                    ]);
				});

			})
		},

		_downloadAction: function() {
		    var nodePaths = [];
            $('tr.is-selected[data-node-path]').each(function(i, item) {
                nodePaths.push(item.dataset['nodePath']);
            });

            var params = $.param({'nodePaths': nodePaths});
            var waitTicker = ui.waitTicker('Loading');
            $.post({
                url: DOWNLOAD_URL,
                data: params
            }).done(function(data) {
                ui.alert('Successfully downloaded.', '', 'success');
            }).fail(function(data) {
                ui.alert('Failed to download translations. ', data.responseJSON.errors + '.', 'error');
            }).always(function(data) {
                waitTicker.clear();
            });
        }
	});
})(document, Granite.$);