<%@ include file="/libs/foundation/global.jsp" %>
<%
%>
<%@ page import="com.day.cq.commons.jcr.JcrConstants,
                 com.day.cq.commons.jcr.JcrUtil,
                 org.apache.commons.lang.RandomStringUtils,
                 org.apache.jackrabbit.util.Text,
                 org.apache.sling.api.resource.Resource,
                 org.apache.sling.api.resource.ResourceResolver,
                 org.apache.sling.commons.json.JSONException,
                 org.apache.sling.commons.json.io.JSONWriter,
                 org.slf4j.Logger,
                 java.io.BufferedReader,
                 java.io.IOException,
                 java.io.Reader" %>
<%@ page import="java.io.StringReader" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Arrays" %>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.Map" %>
<%@ page import="java.util.Set" %>
<%!

    public static class ReaderJSONTokener extends JSONTokener {

        private int index;
        private Reader reader;
        private char lastChar;
        private boolean useLastChar;


        /**
         * Construct a JSONTokener from a string.
         *
         * @param reader     A reader.
         */
        public ReaderJSONTokener(Reader reader) {
            super(null);
            this.reader = reader.markSupported() ?
                    reader : new BufferedReader(reader);
            this.useLastChar = false;
            this.index = 0;
        }


        /**
         * Construct a JSONTokener from a string.
         *
         * @param s     A source string.
         */
        public ReaderJSONTokener(String s) {
            this(new StringReader(s));
        }


        /**
         * Back up one character. This provides a sort of lookahead capability,
         * so that you can test for a digit or letter before attempting to parse
         * the next number or identifier.
         */
        public void back() {
            if (useLastChar || index <= 0) {
                return;
                //throw new JSONException("Stepping back two steps is not supported");
            }
            index -= 1;
            useLastChar = true;
        }


        /**
         * Get the hex value of a character (base16).
         * @param c A character between '0' and '9' or between 'A' and 'F' or
         * between 'a' and 'f'.
         * @return An int between 0 and 15, or -1 if c was not a hex digit.
         */
        public static int dehexchar(char c) {
            if (c >= '0' && c <= '9') {
                return c - '0';
            }
            if (c >= 'A' && c <= 'F') {
                return c - ('A' - 10);
            }
            if (c >= 'a' && c <= 'f') {
                return c - ('a' - 10);
            }
            return -1;
        }


        /**
         * Determine if the source string still contains characters that next()
         * can consume.
         * @return true if not yet at the end of the source.
         */
        public boolean more() {
            char nextChar = next();
            if (nextChar == 0) {
                return false;
            }
            back();
            return true;
        }


        /**
         * Get the next character in the source string.
         *
         * @return The next character, or 0 if past the end of the source string.
         */
        public char next() {
            if (this.useLastChar) {
                this.useLastChar = false;
                if (this.lastChar != 0) {
                    this.index += 1;
                }
                return this.lastChar;
            }
            int c;
            try {
                c = this.reader.read();
            } catch (IOException exc) {
                return 0;
                //throw new JSONException(exc);
            }

            if (c <= 0) { // End of stream
                this.lastChar = 0;
                return 0;
            }
            this.index += 1;
            this.lastChar = (char) c;
            return this.lastChar;
        }


        /**
         * Consume the next character, and check that it matches a specified
         * character.
         * @param c The character to match.
         * @return The character.
         * @throws JSONException if the character does not match.
         */
        public char next(char c) throws JSONException {
            char n = next();
            if (n != c) {
                throw syntaxError("Expected '" + c + "' and instead saw '" +
                        n + "'");
            }
            return n;
        }


        /**
         * Get the next n characters.
         *
         * @param n     The number of characters to take.
         * @return A string of n characters.
         * @throws JSONException
         *   Substring bounds error if there are not
         *   n characters remaining in the source string.
         */
        public String next(int n) throws JSONException {
            if (n == 0) {
                return "";
            }

            char[] buffer = new char[n];
            int pos = 0;

            if (this.useLastChar) {
                this.useLastChar = false;
                buffer[0] = this.lastChar;
                pos = 1;
            }

            try {
                int len;
                while ((pos < n) && ((len = reader.read(buffer, pos, n - pos)) != -1)) {
                    pos += len;
                }
            } catch (IOException exc) {
                throw new JSONException(exc);
            }
            this.index += pos;

            if (pos < n) {
                throw syntaxError("Substring bounds error");
            }

            this.lastChar = buffer[n - 1];
            return new String(buffer);
        }


        /**
         * Get the next char in the string, skipping whitespace.
         * @throws JSONException
         * @return A character, or 0 if there are no more characters.
         */
        public char nextClean() throws JSONException {
            for (; ; ) {
                char c = next();
                if (c == 0 || c > ' ') {
                    return c;
                }
            }
        }


        /**
         * Return the characters up to the next close quote character.
         * Backslash processing is done. The formal JSON format does not
         * allow strings in single quotes, but an implementation is allowed to
         * accept them.
         * @param quote The quoting character, either
         *      <code>"</code>&nbsp;<small>(double quote)</small> or
         *      <code>'</code>&nbsp;<small>(single quote)</small>.
         * @return A String.
         * @throws JSONException Unterminated string.
         */
        public String nextString(char quote) throws JSONException {
            char c;
            StringBuffer sb = new StringBuffer();
            for (; ; ) {
                c = next();
                switch (c) {
                    case 0:
                    case '\n':
                    case '\r':
                        throw syntaxError("Unterminated string");
                    case '\\':
                        c = next();
                        switch (c) {
                            case 'b':
                                sb.append('\b');
                                break;
                            case 't':
                                sb.append('\t');
                                break;
                            case 'n':
                                sb.append('\n');
                                break;
                            case 'f':
                                sb.append('\f');
                                break;
                            case 'r':
                                sb.append('\r');
                                break;
                            case 'u':
                                sb.append((char) Integer.parseInt(next(4), 16));
                                break;
                            case '"':
                            case '\'':
                            case '\\':
                            case '/':
                                sb.append(c);
                                break;
                            default:
                                throw syntaxError("Illegal escape.");
                        }
                        break;
                    default:
                        if (c == quote) {
                            return sb.toString();
                        }
                        sb.append(c);
                }
            }
        }


        /**
         * Get the text up but not including the specified character or the
         * end of line, whichever comes first.
         * @param  d A delimiter character.
         * @return A string.
         */
        public String nextTo(char d) {
            StringBuffer sb = new StringBuffer();
            for (; ; ) {
                char c = next();
                if (c == d || c == 0 || c == '\n' || c == '\r') {
                    if (c != 0) {
                        back();
                    }
                    return sb.toString().trim();
                }
                sb.append(c);
            }
        }


        /**
         * Get the text up but not including one of the specified delimiter
         * characters or the end of line, whichever comes first.
         * @param delimiters A set of delimiter characters.
         * @return A string, trimmed.
         */
        public String nextTo(String delimiters) {
            char c;
            StringBuffer sb = new StringBuffer();
            for (; ; ) {
                c = next();
                if (delimiters.indexOf(c) >= 0 || c == 0 ||
                        c == '\n' || c == '\r') {
                    if (c != 0) {
                        back();
                    }
                    return sb.toString().trim();
                }
                sb.append(c);
            }
        }


        /**
         * Get the next value. The value can be a Boolean, Double, Integer,
         * JSONArray, JSONObject, Long, or String, or the JSONObject.NULL object.
         * @throws JSONException If syntax error.
         *
         * @return An object.
         */
        public Object nextValue() throws JSONException {
            char c = nextClean();
            String s;

            switch (c) {
                case '"':
                case '\'':
                    return nextString(c);
                case '{':
                    back();
                    return new JSONObject(this);
                case '[':
                case '(':
                    back();
                    return new JSONArray(this);
            }

            /*
             * Handle unquoted text. This could be the values true, false, or
             * null, or it can be a number. An implementation (such as this one)
             * is allowed to also accept non-standard forms.
             *
             * Accumulate characters until we reach the end of the text or a
             * formatting character.
             */

            StringBuffer sb = new StringBuffer();
            while (c >= ' ' && ",:]}/\\\"[{;=#".indexOf(c) < 0) {
                sb.append(c);
                c = next();
            }
            back();

            s = sb.toString().trim();
            if (s.equals("")) {
                throw syntaxError("Missing value");
            }
            return stringToValue(s);
        }


        /**
         * Skip characters until the next character is the requested character.
         * If the requested character is not found, no characters are skipped.
         * @param to A character to skip to.
         * @return The requested character, or zero if the requested character
         * is not found.
         */
        public char skipTo(char to) {
            char c;
            try {
                int startIndex = this.index;
                reader.mark(Integer.MAX_VALUE);
                do {
                    c = next();
                    if (c == 0) {
                        reader.reset();
                        this.index = startIndex;
                        return c;
                    }
                } while (c != to);
            } catch (IOException exc) {
                return 0;
                //throw new JSONException(exc);
            }

            back();
            return c;
        }

        /**
         * Make a JSONException to signal a syntax error.
         *
         * @param message The error message.
         * @return A JSONException object, suitable for throwing
         */
        public JSONException syntaxError(String message) {
            return new JSONException(message + toString());
        }


        /**
         * Make a printable string of this JSONTokener.
         *
         * @return " at character [this.index]"
         */
        public String toString() {
            return " at character " + index;
        }

        // ---------------------------------------------------------------
        // Taken from newer JSONObject.stringToValue()

        /**
         * Try to convert a string into a number, boolean, or null. If the string
         * can't be converted, return the string.
         * @param s A String.
         * @return A simple JSON value.
         */
        static public Object stringToValue(String s) {
            if (s.equals("")) {
                return s;
            }
            if (s.equalsIgnoreCase("true")) {
                return Boolean.TRUE;
            }
            if (s.equalsIgnoreCase("false")) {
                return Boolean.FALSE;
            }
            if (s.equalsIgnoreCase("null")) {
                return JSONObject.NULL;
            }

            /*
             * If it might be a number, try converting it. We support the 0- and 0x-
             * conventions. If a number cannot be produced, then the value will just
             * be a string. Note that the 0-, 0x-, plus, and implied string
             * conventions are non-standard. A JSON parser is free to accept
             * non-JSON forms as long as it accepts all correct JSON forms.
             */

            char b = s.charAt(0);
            if ((b >= '0' && b <= '9') || b == '.' || b == '-' || b == '+') {
                if (b == '0') {
                    if (s.length() > 2 &&
                            (s.charAt(1) == 'x' || s.charAt(1) == 'X')) {
                        try {
                            return new Integer(Integer.parseInt(s.substring(2),
                                    16));
                        } catch (Exception e) {
                            /* Ignore the error */
                        }
                    } else {
                        try {
                            return new Integer(Integer.parseInt(s, 8));
                        } catch (Exception e) {
                            /* Ignore the error */
                        }
                    }
                }
                try {
                    if (s.indexOf('.') > -1 || s.indexOf('e') > -1 || s.indexOf('E') > -1) {
                        return Double.valueOf(s);
                    } else {
                        Long myLong = new Long(s);
                        if (myLong.longValue() == myLong.intValue()) {
                            return new Integer(myLong.intValue());
                        } else {
                            return myLong;
                        }
                    }
                } catch (Exception f) {
                    /* Ignore the error */
                }
            }
            return s;
        }
    }

    // --------------------------------------------------------------------------------

    private static final String LANGUAGE_MIXIN = "mix:language";

    private static final String SLING_MESSAGE_MIXIN = "sling:Message";

    private static final String SLING_KEY_PROP = "sling:key";

    private static final String SLING_MESSAGE_PROP = "sling:message";

    /** Maps "path + lang" => map of "key" => "node path" */
    private Map<String, Map<String, String>> storedTranslations = new HashMap<String, Map<String, String>>();


    /**
     * Maps "path + lang" => map of "lower-case node name" => "real node name".
     * Required to avoid case-insensitive duplicate node names.
     **/
    private Map<String, Map<String, String>> storedLowerCaseNodeNames = new HashMap<String, Map<String, String>>();

    private Logger log;

    private String path;

    private int treeDepth = 0;

    private Map<String, String> getStoredTranslations(Node languageNode) throws RepositoryException {
        String path = languageNode.getPath();
        if (!storedTranslations.containsKey(path)) {
            // maps "key" to "node path"
            Map<String, String> translations = new HashMap<String, String>();
            storedTranslations.put(path, translations);

            // add existing translations from nodes
            // search entire subtree below the languageNode
            String query = "/jcr:root" + languageNode.getPath() + "//*[@sling:message]";
            QueryManager qm = languageNode.getSession().getWorkspace().getQueryManager();
            NodeIterator messageNodes = qm.createQuery(query, Query.XPATH).execute().getNodes();
            //NodeIterator messageNodes = languageNode.getNodes();
            while (messageNodes.hasNext()) {
                Node node = messageNodes.nextNode();
                try {
                    if (node.isNodeType(SLING_MESSAGE_MIXIN)) {
                        if (node.hasProperty(SLING_KEY_PROP)) {
                            translations.put(node.getProperty(SLING_KEY_PROP).getString(), node.getPath());
                        } else {
                            // use node name as fallback
                            translations.put(node.getName(), node.getPath());
                        }
                    }
                } catch (Exception e) {
                    // catch PathNotFound and NPEs if the sling:Message node is not correct
                    log.warn("Error while reading existing translation inside '" + path + "'", e);
                }
            }
        }
        return storedTranslations.get(path);
    }

    private Map<String, String> getStoredLowerCaseNodeNames(Node languageNode) throws RepositoryException {
        String path = languageNode.getPath();
        if (!storedLowerCaseNodeNames.containsKey(path)) {
            // set of node names
            Map<String, String> lowerCaseNodeNames = new HashMap<String, String>();
            storedLowerCaseNodeNames.put(path, lowerCaseNodeNames);

            // add existing translations from nodes
            // search entire subtree below the languageNode
            String query = "/jcr:root" + languageNode.getPath() + "//*[@sling:message]";
            QueryManager qm = languageNode.getSession().getWorkspace().getQueryManager();
            NodeIterator messageNodes = qm.createQuery(query, Query.XPATH).execute().getNodes();
            //NodeIterator messageNodes = languageNode.getNodes();
            while (messageNodes.hasNext()) {
                Node node = messageNodes.nextNode();
                lowerCaseNodeNames.put(node.getName().toLowerCase(), node.getName());
            }
        }
        return storedLowerCaseNodeNames.get(path);
    }

    private static String getNodeName(String source) {
        // remove leading & trailing whitespaces
        source = source.trim();
        // maximum 50 characters for the node name
        source = source.substring(0, source.length() > 50 ? 50 : source.length());
        // #19921 - I18n node names should be filesystem compatible for CQDE
        source = source.replaceAll(":", "_");
        source = source.replaceAll("/", "_");
        source = source.replaceAll("<", "_");
        source = source.replaceAll(">", "_");
        // finally convert to valid jcr node name string
        return Text.escapeIllegalJcrChars(source);
    }

    private static String getKey(String source, String comment) {
        if (comment != null && comment.length() > 0) {
            return source + " ((" + comment + "))";
        }
        return source;
    }

    private static String getCommentForLog(String comment) {
        if (comment != null) {
            return " (comment: " + comment + ")";
        }
        return "";
    }

    private String calculateFolderPath(String nodeName) {
        StringBuilder path = new StringBuilder();
        int i = 0;
        for (int n = 0; n < nodeName.length() && i < treeDepth; n++) {
            char c = nodeName.charAt(n);
            // alphanum
            if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') || (c >= '0' && c <= '9')) {
                // keep everything lower case to avoid bugs #26543 and #19921
                path.append(Character.toLowerCase(c));
                path.append("/");
                i++;
            }
        }
        path.append(nodeName);
        return path.toString();
    }

    private void addTranslation(String source, String comment, String language, Node languageNode, String target) {
        try {
            Session session = languageNode.getSession();

            // eg. /libs/configResource/de
            if (languageNode == null) {
                languageNode = JcrUtil.createPath(this.path + "/" + language, JcrConstants.NT_FOLDER, session);
            }

            // ensure mixin mix:language
            if (!languageNode.isNodeType(LANGUAGE_MIXIN)) {
                languageNode.addMixin(LANGUAGE_MIXIN);
            }
            // ensure language property set
            if (!languageNode.hasProperty(JcrConstants.JCR_LANGUAGE)) {
                languageNode.setProperty(JcrConstants.JCR_LANGUAGE, language);
            }

            String key = getKey(source, comment);

            Node messageNode = null;

            // check for an existing sling:key property
            // maps "key" to "node path"
            Map<String, String> translations = getStoredTranslations(languageNode);
            if (translations.containsKey(key)) {
                messageNode = (Node) session.getItem(translations.get(key));
                if (messageNode.hasProperty(SLING_MESSAGE_PROP)) {
                    String existingTranslation = messageNode.getProperty(SLING_MESSAGE_PROP).getString();
                    // check if translation for that key is the same
                    if (target.equals(existingTranslation)) {
                        log.info(language + ": skipping repeated translation '" + source + "' => '" +
                                target + "'" + getCommentForLog(comment) + " :: '" + messageNode.getPath() + "'");
                        // stop here
                        return;
                    } else {
                        log.info(language + ": overwriting old translation for '" + source + "', " +
                                "existing translation: '" + existingTranslation + "', " + "new translation: '" + target + "'" +
                                getCommentForLog(comment) + " :: '" + messageNode.getPath() + "'");
                    }
                } else {
                    log.warn("existing message node without translation (sling:message) found '" + messageNode.getPath() + "'");
                }
            }

            Map<String, String> lowerCaseNodeNames = getStoredLowerCaseNodeNames(languageNode);

            // create new node if we don't overwrite an existing one
            if (messageNode == null) {
                String nodeNameHint = getNodeName(source);

                // #19921 - I18n node names should be filesystem compatible for CQDE
                if (lowerCaseNodeNames.containsKey(nodeNameHint.toLowerCase())) {
                    // conflict: for case-insensitive filesystems, the two names would be regarded as equal
                    // solution: use existing node name, so that createUniquePath below will create a unique name (appending nr at the end)
                    nodeNameHint = lowerCaseNodeNames.get(nodeNameHint.toLowerCase());
                }

                String pathHint = languageNode.getPath() + "/" + calculateFolderPath(nodeNameHint);
                messageNode = JcrUtil.createUniquePath(pathHint, JcrConstants.NT_FOLDER, session);
            }

            log.info(language + ": translating '" + source + "' => '" + target + "'" +
                    getCommentForLog(comment) + " :: '" + messageNode.getPath() + "'");

            // ensure mixin mix:language
            if (!messageNode.isNodeType(SLING_MESSAGE_MIXIN)) {
                messageNode.addMixin(SLING_MESSAGE_MIXIN);
            }

            // only set key property if the node name is not sufficient
            if (!messageNode.getName().equals(key)) {
                messageNode.setProperty(SLING_KEY_PROP, key);
            }
            messageNode.setProperty(SLING_MESSAGE_PROP, target);

            translations.put(key, messageNode.getPath());
            lowerCaseNodeNames.put(messageNode.getName().toLowerCase(), messageNode.getName());

        } catch (RepositoryException e) {
            log.error("could not add translation unit to '" + this.path + "/" + language + "'", e);
        }

    }

    private void deleteTranslation(String key, Node languageNode) {
        try {
            Session session = languageNode.getSession();

            // maps "key" to "node path"
            Map<String, String> translations = getStoredTranslations(languageNode);
            if (translations.containsKey(key)) {
                Node messageNode = (Node) session.getItem(translations.get(key));
                log.info("deleting translation " + messageNode.getPath());
                messageNode.remove();
                translations.remove(key);
            }

        } catch (RepositoryException e) {
            log.error("could not delete translation '" + key + "'", e);
        }
    }
%><%

    this.log = log;

    JSONObject obj = new JSONObject(new ReaderJSONTokener(slingRequest.getReader()));

    this.path = request.getParameter("path");
    if (this.path == null && obj.has("path")) this.path = obj.getString("path");
    if (this.path == null) this.path = "/etc/smartling/configuration";

    ResourceResolver rr = slingRequest.getResourceResolver();
    Resource configResource = rr.getResource(path);
    if (configResource == null) {
        response.sendError(400, "Path '" + path + "' not found.");
        return;
    }

%><%--

    POST requests supported:

    * CREATE (add source) and UPDATE (change translation):
    => POST /libs/cq/configResource/translator.translations.json

    * DELETE (remove source and all its translations)
    => POST /libs/cq/configResource/translator.translations.delete.json

    * JSON format:

    {
        'translations': [
            { 'string': 'source text', 'comment': 'some hint', 'de': 'deutsch', 'fr' : 'francais' },
            { 'string': '2nd text',    'comment': 'some hint', 'de': 'deutsch', 'fr' : 'francais' }
        ]
    }

--%><%

    Node configNodeRoot = configResource.adaptTo(Node.class);

    boolean isDelete = Arrays.asList(slingRequest.getRequestPathInfo().getSelectors()).contains("delete");

    response.setContentType("application/json");
    response.setCharacterEncoding("utf-8");

    if (isDelete) {
        if (obj.has("translations")) {
            JSONArray ts = obj.getJSONArray("translations");
            String deleteNodeName = ts.getString(0);
            Node deleteNode = configNodeRoot.getNode(deleteNodeName);
            deleteNode.remove();
            configNodeRoot.getSession().save();
        }
    } else {

        ArrayList<HashMap<String, String>> records = new ArrayList<HashMap<String, String>>();
        if (obj.has("translations")) {
            HashMap<String, String> recordValues = new HashMap<String, String>();
            JSONArray ts = obj.getJSONArray("translations");
            for (int i = 0; i < ts.length(); i++) {
                if (isDelete) {
                    // delete all translations
                    String key = ts.getString(i);

                } else {
                    JSONObject t = ts.getJSONObject(i);
                    Iterator<String> keys = t.keys();
                    while (keys.hasNext()) {
                        String key = keys.next();
                        String keyValue = t.get(key).toString();
                        recordValues.put(key, keyValue);
                    }
                }
            }
            records.add(recordValues);
        }


        for (HashMap<String, String> record : records) {
            String nodeName = null;
            Node configNode = null;
            if (record.get("configId") == null || record.get("configId").equalsIgnoreCase("")) {
                nodeName = "config_" + RandomStringUtils.randomAlphanumeric(12);
                configNode = configNodeRoot.addNode(nodeName, "nt:unstructured");

            } else {
                nodeName = record.get("configId");
                configNode = configNodeRoot.getNode(nodeName);
            }

            Set<String> keys = record.keySet();
            for (String key : keys) {
                configNode.setProperty(key, record.get(key));
            }
            configNodeRoot.getSession().save();
        }
    }


    JSONWriter w = new JSONWriter(response.getWriter());
    w.object();
    w.key("success").value(true);
    w.endObject();
%>