CQ.Ext.ns('SMARTLING.ui');

SMARTLING.ui.SelectLanguagesDialog = CQ.Ext.extend(CQ.Ext.Window, {
    constructor: function (config) {
        var dialog = this;

        var checkboxConfigs = config.languages.map(function (language) {
            return {
                name: language.code,
                boxLabel: language.name
            };
        });

        this.targetLanguagesCheckboxes = new CQ.Ext.form.CheckboxGroup({
            items: checkboxConfigs,
            allowBlank: false,
            blankText: 'At least one languages should be selected',
            hideLabel: true,
            columns: 2
        });

        CQ.Ext.applyIf(config, {
            y: 120,
            title: 'Send for Translation',
            frame: true,
            labelWidth: 110,
            width: 250,
            height: 250,
            modal: true,
            items: [
                {
                    "title": "Select Languages/Locales",
                    "items": [
                        this.targetLanguagesCheckboxes
                    ]
                }
            ],
            buttons: [
                {
                    text: 'Send',
                    handler: function() {
                        var selectedLanguagesArray = dialog.targetLanguagesCheckboxes.getValue();
                        var selectedLanguages = selectedLanguagesArray.map(function (language){
                            return language.name;
                        });

                        config.handler(dialog, selectedLanguages);
                    }
                },
                {
                    text: "Cancel",
                    handler: function() {
                        dialog.close();
                    }
                }
            ]
        });

        SMARTLING.ui.SelectLanguagesDialog.superclass.constructor.call(this, config);
    }
});
CQ.Ext.reg('smartling-translation-dialog', SMARTLING.ui.SelectLanguagesDialog);